// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the SAMPLEBREAKPOINTHANDLER_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// EXPORT_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef SAMPLEBREAKPOINTHANDLER_EXPORTS
#define EXPORT_API __declspec( dllexport )
#else
#define EXPORT_API __declspec( dllimport )
#endif

//=====================================
//	Function types.
//=====================================

// The function types for breakpoint-handling.
typedef void (__stdcall* PFnBpPrologCallback)( LPVOID bpAddress, const PROCESS_INFORMATION &piProcessInfo );	// Called first, before processing of the breakpoint has happened.
typedef void (__stdcall* PFnBpCallback)( LPVOID bpAddress, const PROCESS_INFORMATION &piProcessInfo );			// Called after the breakpoint has been processed and the breakpoint (0xCC) has been temporarily removed, replaced with the original code.
typedef void (__stdcall* PFnBpEpilogCallback) ( LPVOID bpAddress, const PROCESS_INFORMATION &piProcessInfo );	// Called after the process being debugged has been resumed.  The breakpoint at this time is still removed and will be added immediately after this call.

// Starting and closing function types.
typedef void (__stdcall* PFnBpStartUp)( HANDLE hProcess, DWORD dwProcessID );
typedef void (__stdcall* PFnBpCleanUp)( HANDLE hProcess, DWORD dwProcessID );

// Starting debugging and stopping debugging.
typedef void (__stdcall* PFnBpProcessAttach)( HANDLE hProcess, DWORD dwProcessID );
typedef void (__stdcall* PFnBpProcessDetach)( HANDLE hProcess, DWORD dwProcessID );

// Remember to use __stdcall on all functions that are being exported.



//=====================================
//	Function definitions.
//=====================================

// StartUp() and CleanUp() MUST be exported via a .DEF file.
void __stdcall StartUp( HANDLE hProcess, DWORD dwProcessID );
void __stdcall CleanUp( HANDLE hProcess, DWORD dwProcessID );

// ProcessAttach() and ProcessDetach() MUST be exported via a .DEF file.
void __stdcall ProcessAttach( HANDLE hProcess, DWORD dwProcessID );
void __stdcall ProcessDetach( HANDLE hProcess, DWORD dwProcessID );

// Functions for breakpoints can be exported either way.
EXPORT_API void __stdcall BPFFunction( LPVOID bpAddress, const PROCESS_INFORMATION &piProcessInfo );